import 'cache.dart';
import 'typedef.dart';

class Memoized1<V, A1> {
  final LruCache<A1, V> _cache;
  final Arg1SelfCallableFunction<V, A1> _body;

  Memoized1(Arg1SelfCallableFunction<V, A1> body, {int capacity = 128})
      : _body = body,
        _cache = LruCache(capacity: capacity);

  V call(A1 arg) => _withLRU(_body)(arg);

  V Function(A1) _withLRU(Arg1SelfCallableFunction<V, A1> body) {
    return (A1 n) {
      final cachedValue = _cache[n];
      return cachedValue ?? (_cache[n] = body(n, _withLRU(body)));
    };
  }
}
